<?php
/*
Plugin Name: Google Analytics Tag for Mobile
Plugin URI: http://kaba-blog.shall-systemservice.co.jp/ga-tag-for-mobile/
Description: 携帯サイトで Google Analytics向けのトラッキングタグを生成するためのプラグイン。
Version: 2011.4.11
Author: kaba
Author URI: http://kaba-blog.shall-systemservice.co.jp/
*/
/*  Copyright 2010 y_kaba

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; If not, see <http://www.gnu.org/licenses/>.
*/
/* Special Thanks !!
  This program was made based on "Ultimate Google Analytics(v1.6.0)" 
  which 'Wilfred van der Deijl' made... 
*/
if ( ! defined( 'GATM_PLUGIN_BASENAME' ) )
	define( 'GATM_PLUGIN_BASENAME', plugin_basename( __FILE__ ) );

if ( ! defined( 'GATM_PLUGIN_NAME' ) )
	define( 'GATM_PLUGIN_NAME', trim( dirname( GATM_PLUGIN_BASENAME ), '/' ) );

if ( ! defined( 'GATM_PLUGIN_DIR' ) )
	define( 'GATM_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . GATM_PLUGIN_NAME );

if ( ! defined( 'GATM_GAPHP_URL' ) ) {
	define( 'GATM_GAPHP_URL', WP_PLUGIN_URL . '/' . GATM_PLUGIN_NAME . '/ga.php');
}

require_once GATM_PLUGIN_DIR . '/common.php';
require_once GATM_PLUGIN_DIR . '/option-manager.php';


// Googleに送信するパス情報を必要なものだけに絞る
function gatm_mod_uri($uri) {
	$p_array = gatm_uri_to_array($uri);

	// KtaiStyle関連のパラメータは送らない設定の場合
	if ( gatm_get_option('uri_ignore_ks_params') ) {
		// KtaiセッションIDは削除
		unset($p_array['ksid']);
		// imgは削除
		unset($p_array['img']);
	}
	// guidは送らない設定の場合
	if ( gatm_get_option('uri_ignore_guid') ) {
		// guidは削除
		unset($p_array['guid']);
	}

	return gatm_array_to_uri($p_array);
}

function gatm_GetImageUrl() {

	// ImageUrlの生成
	$ar = array();
	$ar['uri']   = GATM_GAPHP_URL;
	$ar['param'] = array(
		'utmac'			=> gatm_get_option('account_id'),
		'utmn'			=> rand(0, 0x7fffffff),
		'guid'			=> 'ON',
	);

	// リファラー情報
    $referer = '-';
	if (isset($_SERVER["HTTP_REFERER"])) {
	    $referer = gatm_mod_uri($_SERVER["HTTP_REFERER"]);
	}
	$ar['param']['utmr'] = urlencode($referer);

	// 本リクエストへのパス
    $path = gatm_mod_uri($_SERVER["REQUEST_URI"]);
	$ar['param']['utmp'] = urlencode($path);

	$url = gatm_array_to_uri($ar);
    return str_replace("&", "&amp;", $url);
}

//------------------------------
// トラッキングタグを出力する
//------------------------------
function gatm_googleAnalyticsTag() {
	// bot からのアクセスならトラッキングしない
	$botUAs = array(
		'Googlebot',		// Google
		'Y!J-',				// Yahoo
		'BaiduMobaider',	// Baidu
		'ichiro/mobile',	// Goo
		'moba-crawler',		// mbga
		'symphonybot1.froute.jp',	// froute
		'LD_mobile_bot',	// ケータイlivedoor
	);
	foreach ($botUAs as $keyword) {
		if(ereg($keyword, $_SERVER['HTTP_USER_AGENT'])) return;
	}
	
	// ログインユーザーのトラッキングをしない設定になっている場合
	if ( gatm_get_option('ignore_users') ) {
		// ログインユーザーなら何もしない
		if ( is_user_logged_in() ) return;
	}
	// トラッキングタグを出力する
	echo '<img src="' . gatm_GetImageUrl() . '" />';
}

// プラグインが有効ならトラッキングを行う
if (gatm_get_option('enable_tracker')) {
	add_action('ktai_wp_footer', 'gatm_googleAnalyticsTag');
} else {
	remove_action('ktai_wp_footer', 'gatm_googleAnalyticsTag');
}

?>